package org.hisrc.hifaces20.testing.server.testing;

import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JFrame;
import javax.swing.JLabel;

import org.junit.Test;

public abstract class AbstractRunWebServerEnvironment extends
		AbstractWebServerEnvironmentTest {

	@Test
	public void run() throws Exception {
		final JFrame frame = new JFrame();
		final JLabel label = new JLabel(
				"Close this window when you've finished testing the web application.");
		frame.getContentPane().add(label);

		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.pack();
		frame.setVisible(true);

		frame.addWindowListener(new WindowListener() {

			@Override
			public void windowOpened(WindowEvent e) {
			}

			@Override
			public void windowIconified(WindowEvent e) {
			}

			@Override
			public void windowDeiconified(WindowEvent e) {
			}

			@Override
			public void windowDeactivated(WindowEvent e) {
			}

			@Override
			public void windowClosing(WindowEvent e) {
				try {
					webServerEnvironment.stop();
				} catch (Exception ex) {
					throw new RuntimeException(ex);
				}

			}

			@Override
			public void windowClosed(WindowEvent e) {
			}

			@Override
			public void windowActivated(WindowEvent e) {
			}
		});
		webServerEnvironment.join();
	}

}
